# $Revision: 1.32 $, $Date: 2009/02/07 16:56:46 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif
%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	6
%define		pname	ipset
Summary:	IP sets utility
Summary(pl.UTF-8):	Narzędzie do zarządzania zbiorami IP
Name:		ipset
Version:	2.4.5
Release:	%{rel}
License:	GPL
Group:		Networking/Admin
Source0:	http://ipset.netfilter.org/%{pname}-%{version}.tar.bz2
# Source0-md5:	9cd51ed1a901d8616bb0485b3f23fbe3
Source1:	%{pname}.init
URL:		http://ipset.netfilter.org/
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.20.2}
%{?with_userspace:BuildRequires:	linux-libc-headers >= 7:2.6.22.1-2}
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.379
Requires(post,postun):	/sbin/depmod
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which
can be administered by the ipset utility. Depending on the type,
currently an IP set may store IP addresses, (TCP/UDP) port numbers or
IP addresses with MAC addresses in a way, which ensures lightning
speed when matching an entry against a set.

%description -l pl.UTF-8
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można
administrować przy użyciu narzędzia ipset. W zależności od rodzaju
aktualnie zbiór IP może przechowywać adresy IP, numery portów
(TCP/UDP) lub adresy IP z adresami MAC - w sposób zapewniający
maksymalną szybkość przy dopasowywaniu elementu do zbioru.

%package devel
Summary:	Header files for ipset interface
Summary(pl.UTF-8):	Pliki nagłówkowe do interfejsu ipset
Group:		Development/Libraries

%description devel
Header files for IPset interface.

%description devel -l pl.UTF-8
Pliki nagłówkowe do interfejsu IPset.

%package init
Summary:	IPset init script
Summary(pl.UTF-8):	Skrypt startowy IPset
Group:		Networking/Admin
Requires(post,preun):	/sbin/chkconfig
Requires:	%{pname} = %{version}-%{release}
Requires:	rc-scripts

%description init
IPset initialization script.

%description init -l pl.UTF-8
Skrypt startowy IPset.

%package -n kernel%{_alt_kernel}-net-ipset
Summary:	IPset kernel modules
Summary(pl.UTF-8):	Moduły jądra oferujące wsparcie dla zbiorów IP
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel}
Requires(post,postun):	/sbin/depmod

%description -n kernel%{_alt_kernel}-net-ipset
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which
can be administered by the ipset utility. Depending on the type,
currently an IP set may store IP addresses, (TCP/UDP) port numbers or
IP addresses with MAC addresses in a way, which ensures lightning
speed when matching an entry against a set.

This package contains kernel modules.

%description -n kernel%{_alt_kernel}-net-ipset -l pl.UTF-8
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można
administrować przy użyciu narzędzia ipset. W zależności od rodzaju
aktualnie zbiór IP może przechowywać adresy IP, numery portów
(TCP/UDP) lub adresy IP z adresami MAC - w sposób zapewniający
maksymalną szybkość przy dopasowywaniu elementu do zbioru.

Ten pakiet zawiera moduły jądra oferujące wsparcie dla zbiorów IP.

%prep
%setup -q -n %{pname}-%{version}
mv kernel/{Kbuild,Makefile}

# maximum number of ipsets.
%{__sed} -i 's:$(IP_NF_SET_MAX):256:' kernel/Makefile
# hash size for bindings of IP sets.
%{__sed} -i 's:$(IP_NF_SET_HASHSIZE):1024:' kernel/Makefile
# these options can be overriden by module parameters.

%build
%if %{with userspace}
%{__make} binaries \
	CC="%{__cc}" \
	PREFIX="%{_prefix}" \
	LIBDIR="%{_libdir}" \
	MANDIR="%{_mandir}" \
	BINDIR="%{_sbindir}" \
	COPT_FLAGS:="%{rpmcflags}"
%endif

%if %{with kernel}
# ugly hack for satisfy rpm build macro. in fact all modules will be build.
%build_kernel_modules -C kernel -m ip_set
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_includedir}}

%{__make} binaries_install \
	DESTDIR="$RPM_BUILD_ROOT" \
	PREFIX="%{_prefix}" \
	LIBDIR="%{_libdir}" \
	MANDIR="%{_mandir}" \
	BINDIR="%{_sbindir}"

install *.h $RPM_BUILD_ROOT%{_includedir}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{pname}
%endif

%if %{with kernel}
cd kernel
%install_kernel_modules -m ip_set -d kernel/net/ipv4/netfilter
install ip_set_*.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter
install ipt_*.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter
cd -
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post init
/sbin/chkconfig --add %{pname}

%preun init
if [ "$1" = "0" ]; then
	/sbin/chkconfig --del %{pname}
fi

%post	-n kernel%{_alt_kernel}-net-ipset
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-net-ipset
%depmod %{_kernel_ver}

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc ChangeLog ChangeLog.ippool TODO
%attr(755,root,root) %{_sbindir}/*
%dir %{_libdir}/ipset
%attr(755,root,root) %{_libdir}/ipset/*.so
%{_mandir}/man8/*

%files devel
%defattr(644,root,root,755)
%{_includedir}/*.h

%files init
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/ipset
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-net-ipset
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/*.ko*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ipset.spec,v $
Revision 1.32  2009/02/07 16:56:46  arekm
- release 6

Revision 1.31  2009/01/25 12:55:30  arekm
- release 5

Revision 1.30  2009/01/19 12:30:10  arekm
- release 4

Revision 1.29  2009/01/15 12:53:59  arekm
- release 3

Revision 1.28  2009/01/10 22:37:22  arekm
- release 2

Revision 1.27  2009/01/05 10:32:38  pluto
- updated to 2.4.5.

Revision 1.26  2008/12/19 06:30:49  arekm
- release 8

Revision 1.25  2008/12/14 11:42:42  arekm
- release 7

Revision 1.24  2008/12/06 08:59:56  arekm
- release 6

Revision 1.23  2008/12/04 00:58:49  pluto
- release 5 for 2.6.27.7-3.

Revision 1.22  2008/11/21 19:14:32  arekm
- release 4

Revision 1.21  2008/11/08 09:26:53  arekm
- release 3

Revision 1.20  2008/11/04 08:22:05  pluto
- release 2.

Revision 1.19  2008/10/28 19:17:05  qboosh
- pl for -init, strict dep

Revision 1.18  2008/10/27 13:15:21  glen
- complete alt_kernel support (src.rpm to include alt kernel brand)

Revision 1.17  2008/10/27 13:13:30  glen
- unify (from template-kernel-module.spec)

Revision 1.16  2008/10/27 10:00:16  pluto
- updated to 2.4.3, add kernel modules w/ 2.6.27 support.

Revision 1.15  2008/08/13 15:40:59  kosmo
- updated to 2.3.3a

Revision 1.14  2007/12/11 06:53:32  pluto
- adapterized, init script updated.

Revision 1.13  2007-12-10 20:13:05  pluto
- add init script.

Revision 1.12  2007-10-15 23:46:55  zbyniu
- up to 2.3.0-20070828

Revision 1.11  2007/04/04 09:03:41  gotar
- up to 2.2.9a

Revision 1.10  2007/02/13 08:06:35  glen
- tabs in preamble

Revision 1.9  2007/02/12 00:48:57  baggins
- converted to UTF-8

Revision 1.8  2006/06/09 15:35:26  wolf
- cosmetics

Revision 1.7  2006/01/26 19:48:53  dzeus
- up to 2.2.8

Revision 1.6  2005/12/13 20:10:43  qboosh
- fixed -devel descs

Revision 1.5  2005/12/11 13:04:59  djrzulf
- created devel subpackage, i think right :),

Revision 1.4  2005/11/24 11:01:15  pluto
- updated to 2.2.7, all modules enabled, release 1.

Revision 1.3  2005/11/14 21:17:30  qboosh
- pl

Revision 1.2  2005/11/09 12:40:42  jajcus
- patch for Makefile not to use kernel headers (from /usr/src)

Revision 1.1  2005/11/09 10:57:18  jajcus
- new spec
